uninstall.sh 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372
  1. #!/bin/bash
  2. # Author: yeho <lj2007331 AT gmail.com>
  3. # BLOG: https://blog.linuxeye.com
  4. #
  5. # Notes: OneinStack for CentOS/RadHat 6+ Debian 7+ and Ubuntu 12+
  6. #
  7. # Project home page:
  8. # https://oneinstack.com
  9. # https://github.com/lj2007331/oneinstack
  10. export PATH=/usr/local/sbin:/usr/local/bin:/sbin:/bin:/usr/sbin:/usr/bin
  11. clear
  12. printf "
  13. #######################################################################
  14. # OneinStack for CentOS/RadHat 6+ Debian 7+ and Ubuntu 12+ #
  15. # Uninstall OneinStack #
  16. # For more information please visit https://oneinstack.com #
  17. #######################################################################
  18. "
  19. . ./options.conf
  20. . ./include/color.sh
  21. . ./include/get_char.sh
  22. . ./include/check_dir.sh
  23. # Check if user is root
  24. [ $(id -u) != "0" ] && { echo "${CFAILURE}Error: You must be root to run this script${CEND}"; exit 1; }
  25. Usage(){
  26. printf "
  27. Usage: $0 [ ${CMSG}all${CEND} | ${CMSG}web${CEND} | ${CMSG}db${CEND} | ${CMSG}php${CEND} | ${CMSG}hhvm${CEND} | ${CMSG}pureftpd${CEND} | ${CMSG}redis${CEND} | ${CMSG}memcached${CEND} ]
  28. ${CMSG}all${CEND} --->Uninstall All
  29. ${CMSG}web${CEND} --->Uninstall Nginx/Tengine/Apache/Tomcat
  30. ${CMSG}db${CEND} --->Uninstall MySQL/MariaDB/Percona/AliSQL/PostgreSQL/MongoDB
  31. ${CMSG}php${CEND} --->Uninstall PHP
  32. ${CMSG}hhvm${CEND} --->Uninstall HHVM
  33. ${CMSG}pureftpd${CEND} --->Uninstall PureFtpd
  34. ${CMSG}redis${CEND} --->Uninstall Redis
  35. ${CMSG}memcached${CEND} --->Uninstall Memcached
  36. "
  37. }
  38. Uninstall_status() {
  39. while :; do echo
  40. read -p "Do you want to uninstall? [y/n]: " uninstall_yn
  41. echo
  42. if [[ ! ${uninstall_yn} =~ ^[y,n]$ ]]; then
  43. echo "${CWARNING}input error! Please only input 'y' or 'n'${CEND}"
  44. else
  45. break
  46. fi
  47. done
  48. }
  49. Print_Warn() {
  50. echo
  51. echo "${CWARNING}You will uninstall OneinStack, Please backup your configure files and DB data! ${CEND}"
  52. }
  53. Print_web() {
  54. [ -d "${nginx_install_dir}" ] && echo "${nginx_install_dir}"
  55. [ -d "${tengine_install_dir}" ] && echo "${tengine_install_dir}"
  56. [ -d "${openresty_install_dir}" ] && echo "${openresty_install_dir}"
  57. [ -e "/etc/init.d/nginx" ] && echo '/etc/init.d/nginx'
  58. [ -e "/etc/logrotate.d/nginx" ] && echo '/etc/logrotate.d/nginx'
  59. [ -d "${apache_install_dir}" ] && echo "${apache_install_dir}"
  60. [ -e "/etc/init.d/httpd" ] && echo "/etc/init.d/httpd"
  61. [ -e "/etc/logrotate.d/apache" ] && echo "/etc/logrotate.d/apache"
  62. [ -d "${tomcat_install_dir}" ] && echo "${tomcat_install_dir}"
  63. [ -e "/etc/init.d/tomcat" ] && echo "/etc/init.d/tomcat"
  64. [ -e "/etc/logrotate.d/tomcat" ] && echo "/etc/logrotate.d/tomcat"
  65. [ -d "/usr/java" ] && echo '/usr/java'
  66. [ -d "/usr/local/apr" ] && echo '/usr/local/apr'
  67. }
  68. Uninstall_Web() {
  69. [ -d "${nginx_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${nginx_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${nginx_install_dir}/sbin:@@" /etc/profile; }
  70. [ -d "${tengine_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${tengine_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${tengine_install_dir}/sbin:@@" /etc/profile; }
  71. [ -d "${openresty_install_dir}" ] && { killall nginx > /dev/null 2>&1; rm -rf ${openresty_install_dir} /etc/init.d/nginx /etc/logrotate.d/nginx; sed -i "s@${openresty_install_dir}/nginx/sbin:@@" /etc/profile; }
  72. [ -d "${apache_install_dir}" ] && { service httpd stop > /dev/null 2>&1; rm -rf ${apache_install_dir} /etc/init.d/httpd /etc/logrotate.d/apache; sed -i "s@${apache_install_dir}/bin:@@" /etc/profile; }
  73. [ -d "${tomcat_install_dir}" ] && { killall java > /dev/null 2>&1; chmod +x /etc/logrotate.d/tomcat; rm -rf ${tomcat_install_dir} /etc/init.d/tomcat /etc/logrotate.d/tomcat /usr/local/apr; }
  74. [ -d "/usr/java" ] && { rm -rf /usr/java; sed -i '/export JAVA_HOME=/d' /etc/profile; sed -i '/export CLASSPATH=/d' /etc/profile; sed -i 's@\$JAVA_HOME/bin:@@' /etc/profile; }
  75. [ -e "${wwwroot_dir}" ] && /bin/mv ${wwwroot_dir}{,$(date +%Y%m%d%H)}
  76. sed -i 's@^website_name=.*@website_name=@' ./options.conf
  77. sed -i 's@^local_bankup_yn=.*@local_bankup_yn=y@' ./options.conf
  78. sed -i 's@^remote_bankup_yn=.*@remote_bankup_yn=n@' ./options.conf
  79. echo "${CMSG}Web uninstall completed${CEND}"
  80. }
  81. Print_DB() {
  82. [ -e "${db_install_dir}" ] && echo "${db_install_dir}"
  83. [ -e "/etc/init.d/mysqld" ] && echo "/etc/init.d/mysqld"
  84. [ -e "/etc/my.cnf" ] && echo "/etc/my.cnf"
  85. [ -e "${pgsql_install_dir}" ] && echo "${pgsql_install_dir}"
  86. [ -e "/etc/init.d/postgresql" ] && echo "/etc/init.d/postgresql"
  87. [ -e "${mongo_install_dir}" ] && echo "${mongo_install_dir}"
  88. [ -e "/etc/init.d/mongod" ] && echo "/etc/init.d/mongod"
  89. }
  90. Uninstall_DB() {
  91. # uninstall mysql,mariadb,percona,alisql
  92. if [ -d "${db_install_dir}/support-files" ];then
  93. service mysqld stop > /dev/null 2>&1
  94. rm -rf ${db_install_dir} /etc/init.d/mysqld /etc/my.cnf /etc/ld.so.conf.d/{mysql,mariadb,percona,alisql}*.conf
  95. id -u mysql >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel mysql
  96. [ -e "${db_data_dir}" ] && /bin/mv ${db_data_dir}{,$(date +%Y%m%d%H)}
  97. sed -i 's@^dbrootpwd=.*@dbrootpwd=@' ./options.conf
  98. sed -i "s@${db_install_dir}/bin:@@" /etc/profile
  99. fi
  100. # uninstall postgresql
  101. if [ -e "${pgsql_install_dir}/bin/psql" ]; then
  102. service postgresql stop > /dev/null 2>&1
  103. rm -rf ${pgsql_install_dir} /etc/init.d/postgresql ${php_install_dir}/etc/php.d/ext-pgsql.ini
  104. id -u postgres >/dev/null 2>&1 ; [ $? -eq 0 ] && userdel postgres
  105. [ -e "${pgsql_data_dir}" ] && /bin/mv ${pgsql_data_dir}{,$(date +%Y%m%d%H)}
  106. sed -i 's@^dbpostgrespwd=.*@dbpostgrespwd=@' ./options.conf
  107. sed -i "s@${pgsql_install_dir}/bin:@@" /etc/profile
  108. echo "${CMSG}PostgreSQL uninstall completed${CEND}"
  109. fi
  110. # uninstall mongodb
  111. if [ -e "${mongo_install_dir}/bin/mongo" ]; then
  112. service mongod stop > /dev/null 2>&1
  113. rm -rf ${mongo_install_dir} /etc/mongod.conf /etc/init.d/mongod /var/log/mongodb /tmp/mongo*.sock
  114. id -u mongod > /dev/null 2>&1 ; [ $? -eq 0 ] && userdel mongod
  115. [ -e "${mongo_data_dir}" ] && /bin/mv ${mongo_data_dir}{,$(date +%Y%m%d%H)}
  116. sed -i 's@^dbmongopwd=.*@dbmongopwd=@' ./options.conf
  117. sed -i "s@${mongo_install_dir}/bin:@@" /etc/profile
  118. echo "${CMSG}MongoDB uninstall completed${CEND}"
  119. fi
  120. }
  121. Print_PHP() {
  122. [ -e "${php_install_dir}" ] && echo "${php_install_dir}"
  123. [ -e "/etc/init.d/php-fpm" ] && echo "/etc/init.d/php-fpm"
  124. [ -e "/usr/local/imagemagick" ] && echo "/usr/local/imagemagick"
  125. [ -e "/usr/local/graphicsmagick" ] && echo '/usr/local/graphicsmagick'
  126. }
  127. Uninstall_PHP() {
  128. [ -e "${php_install_dir}/bin/phpize" -a -e "${php_install_dir}/etc/php-fpm.conf" ] && { service php-fpm stop > /dev/null 2>&1; rm -rf ${php_install_dir} /etc/init.d/php-fpm; }
  129. [ -e "${php_install_dir}/bin/phpize" -a ! -e "${php_install_dir}/etc/php-fpm.conf" ] && rm -rf ${php_install_dir}
  130. [ -e "/usr/local/imagemagick" ] && rm -rf /usr/local/imagemagick
  131. [ -e "/usr/local/graphicsmagick" ] && rm -rf /usr/local/graphicsmagick
  132. sed -i "s@${php_install_dir}/bin:@@" /etc/profile
  133. echo "${CMSG}PHP uninstall completed${CEND}"
  134. }
  135. Print_HHVM() {
  136. [ -e "/usr/bin/hhvm" ] && echo "/usr/bin/hhvm"
  137. [ -e "/etc/hhvm" ] && echo "/etc/hhvm"
  138. [ -e "/var/log/hhvm" ] && echo "/var/log/hhvm"
  139. [ -e "/etc/supervisord.conf" ] && echo "/etc/supervisord.conf"
  140. [ -e "/etc/init.d/supervisord" ] && echo "/etc/init.d/supervisord"
  141. }
  142. Uninstall_HHVM() {
  143. [ -e "/etc/init.d/supervisord" ] && { service supervisord stop > /dev/null 2>&1; rm -rf /etc/supervisord.conf /etc/init.d/supervisord; }
  144. [ -e "/usr/bin/hhvm" ] && { rpm -e hhvm; rm -rf /etc/hhvm /var/log/hhvm /usr/bin/hhvm; }
  145. echo "${CMSG}HHVM uninstall completed${CEND}"
  146. }
  147. Print_PureFtpd() {
  148. [ -e "$pureftpd_install_dir" ] && echo "$pureftpd_install_dir"
  149. [ -e "/etc/init.d/pureftpd" ] && echo "/etc/init.d/pureftpd"
  150. }
  151. Uninstall_PureFtpd() {
  152. [ -e "$pureftpd_install_dir" ] && { service pureftpd stop > /dev/null 2>&1; rm -rf $pureftpd_install_dir /etc/init.d/pureftpd; }
  153. echo "${CMSG}Pureftpd uninstall completed${CEND}"
  154. }
  155. Print_Redis() {
  156. [ -e "$redis_install_dir" ] && echo "$redis_install_dir"
  157. [ -e "/etc/init.d/redis-server" ] && echo "/etc/init.d/redis-server"
  158. }
  159. Uninstall_Redis() {
  160. [ -e "$redis_install_dir" ] && { service redis-server stop > /dev/null 2>&1; rm -rf $redis_install_dir /etc/init.d/redis-server /usr/local/bin/redis-*; }
  161. [ -e "${php_install_dir}/etc/php.d/ext-redis.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-redis.ini
  162. echo "${CMSG}Redis uninstall completed${CEND}"
  163. }
  164. Print_Memcached() {
  165. [ -e "${memcached_install_dir}" ] && echo "${memcached_install_dir}"
  166. [ -e "/etc/init.d/memcached" ] && echo "/etc/init.d/memcached"
  167. [ -e "/usr/bin/memcached" ] && echo "/usr/bin/memcached"
  168. }
  169. Uninstall_Memcached() {
  170. [ -e "${memcached_install_dir}" ] && { service memcached stop > /dev/null 2>&1; rm -rf ${memcached_install_dir} /etc/init.d/memcached /usr/bin/memcached; }
  171. [ -e "${php_install_dir}/etc/php.d/ext-memcache.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-memcache.ini
  172. [ -e "${php_install_dir}/etc/php.d/ext-memcached.ini" ] && rm -rf ${php_install_dir}/etc/php.d/ext-memcached.ini
  173. echo "${CMSG}Memcached uninstall completed${CEND}"
  174. }
  175. Print_curlopenssl() {
  176. [ -e "/usr/local/bin/curl" ] && echo "/usr/local/bin/curl"
  177. [ -d "${openssl_install_dir}" ] && echo "${openssl_install_dir}"
  178. }
  179. Uninstall_curlopenssl() {
  180. [ -e "/usr/local/bin/curl" ] && rm -rf /usr/local/lib/libcurl* /usr/local/bin/curl
  181. [ -d "${openssl_install_dir}" ] && { rm -rf ${openssl_install_dir} /etc/ld.so.conf.d/z.openssl.conf; ldconfig; }
  182. }
  183. Menu(){
  184. while :; do
  185. printf "
  186. What Are You Doing?
  187. \t${CMSG}0${CEND}. Uninstall All
  188. \t${CMSG}1${CEND}. Uninstall Nginx/Tengine/Apache/Tomcat
  189. \t${CMSG}2${CEND}. Uninstall MySQL/MariaDB/Percona/AliSQL/PostgreSQL/MongoDB
  190. \t${CMSG}3${CEND}. Uninstall PHP
  191. \t${CMSG}4${CEND}. Uninstall HHVM
  192. \t${CMSG}5${CEND}. Uninstall PureFtpd
  193. \t${CMSG}6${CEND}. Uninstall Redis
  194. \t${CMSG}7${CEND}. Uninstall Memcached
  195. \t${CMSG}q${CEND}. Exit
  196. "
  197. echo
  198. read -p "Please input the correct option: " Number
  199. if [[ ! $Number =~ ^[0-7,q]$ ]]; then
  200. echo "${CWARNING}input error! Please only input 0~7 and q${CEND}"
  201. else
  202. case "$Number" in
  203. 0)
  204. Print_Warn
  205. Print_web
  206. Print_DB
  207. Print_PHP
  208. Print_HHVM
  209. Print_PureFtpd
  210. Print_Redis
  211. Print_Memcached
  212. Print_curlopenssl
  213. Uninstall_status
  214. if [ "${uninstall_yn}" == 'y' ]; then
  215. Uninstall_Web
  216. Uninstall_DB
  217. Uninstall_PHP
  218. Uninstall_HHVM
  219. Uninstall_PureFtpd
  220. Uninstall_Redis
  221. Uninstall_Memcached
  222. Uninstall_curlopenssl
  223. else
  224. exit
  225. fi
  226. ;;
  227. 1)
  228. Print_Warn
  229. Print_web
  230. Uninstall_status
  231. [ "${uninstall_yn}" == 'y' ] && Uninstall_Web || exit
  232. ;;
  233. 2)
  234. Print_Warn
  235. Print_DB
  236. Uninstall_status
  237. [ "${uninstall_yn}" == 'y' ] && Uninstall_DB || exit
  238. ;;
  239. 3)
  240. Print_PHP
  241. Uninstall_status
  242. [ "${uninstall_yn}" == 'y' ] && Uninstall_PHP || exit
  243. ;;
  244. 4)
  245. Print_HHVM
  246. Uninstall_status
  247. [ "${uninstall_yn}" == 'y' ] && Uninstall_HHVM || exit
  248. ;;
  249. 5)
  250. Print_PureFtpd
  251. Uninstall_status
  252. [ "${uninstall_yn}" == 'y' ] && Uninstall_PureFtpd || exit
  253. ;;
  254. 6)
  255. Print_Redis
  256. Uninstall_status
  257. [ "${uninstall_yn}" == 'y' ] && Uninstall_Redis || exit
  258. ;;
  259. 7)
  260. Print_Memcached
  261. Uninstall_status
  262. [ "${uninstall_yn}" == 'y' ] && Uninstall_Memcached || exit
  263. ;;
  264. q)
  265. exit
  266. ;;
  267. esac
  268. fi
  269. done
  270. }
  271. if [ $# == 0 ]; then
  272. Menu
  273. elif [ $# == 1 ]; then
  274. case $1 in
  275. all)
  276. Print_Warn
  277. Print_web
  278. Print_DB
  279. Print_PHP
  280. Print_HHVM
  281. Print_PureFtpd
  282. Print_Redis
  283. Print_Memcached
  284. Print_curlopenssl
  285. Uninstall_status
  286. if [ "${uninstall_yn}" == 'y' ]; then
  287. Uninstall_Web
  288. Uninstall_DB
  289. Uninstall_PHP
  290. Uninstall_HHVM
  291. Uninstall_PureFtpd
  292. Uninstall_Redis
  293. Uninstall_Memcached
  294. Uninstall_curlopenssl
  295. else
  296. exit
  297. fi
  298. ;;
  299. web)
  300. Print_Warn
  301. Print_web
  302. Uninstall_status
  303. [ "${uninstall_yn}" == 'y' ] && Uninstall_Web || exit
  304. ;;
  305. db)
  306. Print_Warn
  307. Print_DB
  308. Uninstall_status
  309. [ "${uninstall_yn}" == 'y' ] && Uninstall_DB || exit
  310. ;;
  311. php)
  312. Print_PHP
  313. Uninstall_status
  314. [ "${uninstall_yn}" == 'y' ] && Uninstall_PHP || exit
  315. ;;
  316. hhvm)
  317. Print_HHVM
  318. Uninstall_status
  319. [ "${uninstall_yn}" == 'y' ] && Uninstall_HHVM || exit
  320. ;;
  321. pureftpd)
  322. Print_PureFtpd
  323. Uninstall_status
  324. [ "${uninstall_yn}" == 'y' ] && Uninstall_PureFtpd || exit
  325. ;;
  326. redis)
  327. Print_Redis
  328. Uninstall_status
  329. [ "${uninstall_yn}" == 'y' ] && Uninstall_Redis || exit
  330. ;;
  331. memcached)
  332. Print_Memcached
  333. Uninstall_status
  334. [ "${uninstall_yn}" == 'y' ] && Uninstall_Memcached || exit
  335. ;;
  336. *)
  337. Usage
  338. ;;
  339. esac
  340. else
  341. Usage
  342. fi